biko
====

A simple client-server CRUD application communicating over WebSocket. The client can send basic user information to the server (first name, last name, etc) to be stored to the database. The client can also read, delete, and update existing user information on the server. This is for demonstration purposes only.


Technologies
--------------------

* AutobahnPython
* Peewee
* Python 3.5
* Twisted


Installation
--------------------

Create a virtual environment then use `pip` to install the package.

```sh
pip install https://bitbucket.org/pvergil/biko/downloads/biko-0.1.tar.gz
```


Server usage
--------------------

Running the server.

```sh
bikoserver --port 8080
```


Client usage
--------------------

If the `--host` and `--port` options are not provided, the default host (127.0.0.1) and port (8080) is used.

Creating new users.

```sh
bikoclient --host 192.168.1.1 --port 8080 create --fname Jane --lname Doe --sex F --bdate 1990-12-25
bikoclient --host 192.168.1.1 --port 8080 create --fname John --lname Doe --sex F --bdate 1991-01-01
bikoclient --host 192.168.1.1 --port 8080 create --fname Jade --lname Doe --sex F --bdate 1990-11-11
bikoclient --host 192.168.1.1 --port 8080 create --fname Jude --lname Doe --sex F --bdate 1990-02-11
bikoclient --host 192.168.1.1 --port 8080 create --fname June --lname Doe --sex F --bdate 1990-06-11
bikoclient --host 192.168.1.1 --port 8080 create --fname Gwen --lname Doe --sex F --bdate 1990-05-15
bikoclient --host 192.168.1.1 --port 8080 create --fname Will --lname Doe --sex F --bdate 1990-07-15
```

Updating an existing user.

``sh
bikoclient --host 192.168.1.1 --port 8080 update 123 --fname Will
``

Deleting an existing user.

```sh
bikoclient --host 192.168.1.1 --port 8080 delete 123
```

Fetching an single user.

```sh
bikoclient --host 192.168.1.1 --port 8080 fetch 123
```

Fetching all users.

```sh
bikoclient --host 192.168.1.1 --port 8080 fetch
```
