from argparse import ArgumentParser

from twisted.internet import reactor

from .models import database, User
from .protocol import ServerProtocolFactory


def tables():
    """
    Create database tables.
    """
    tables = [
        User
    ]

    database.create_tables(tables, safe=True)


def start(args):
    print('Listening on port: {0}...'.format(args.port))

    # Listen on a specific port.
    reactor.listenTCP(args.port, ServerProtocolFactory())

    # Start the engine.
    reactor.run()


def main():

    parser = ArgumentParser()

    parser.add_argument('--port', type=int, default=8080,
                        help='the port to listen to (default is 8080)')

    # Create database tables.
    tables()

    # Start the server.
    start(parser.parse_args())


if __name__ == '__main__':
    main()
