from datetime import datetime
from os.path import expanduser

from peewee import CharField, DateTimeField, Model, SqliteDatabase


database = SqliteDatabase('{0}/biko.sqlite'.format(expanduser('~')))


class User(Model):

    fname = CharField()
    lname = CharField()

    # Date the row was created.
    created = DateTimeField(null=True)

    # Date the row was updated.
    updated = DateTimeField(null=True)

    class Meta:
        database = database

    def save(self, *args, **kwargs):
        if not self.created:
            self.created = datetime.now()
        else:
            self.updated = datetime.now()

        return super().save(*args, **kwargs)

    def __str__(self):
        return '[{id}] {lname}, {fname}'.format(**self.dictionary)

    @property
    def dictionary(self):
        return {'id': self.id, 'fname': self.lname, 'lname': self.fname}
