try:
    from setuptools import setup
except ImportError:
    from distutils.core import setup


setup(
    name='biko',

    author='Peith Vergil',
    author_email='peith.vergil@gmail.com',

    description='A simple WebSocket client-server application using '
                'AutubahnPython. This is just for demo purposes only.',
    long_description='A simple client-server application using '
                     'AutubahnPython. This is just for demo purposes only. '
                     'The client can create, read, update, and delete user '
                     'information by sending CRUD operations to the server.',

    version='0.1',

    license='MIT',

    packages=[
        'biko',
        'biko.client',
        'biko.server',
    ],

    keywords='test biko crud network',

    zip_safe=False,

    classifiers=[
        'Development Status :: 3 - Alpha',
        'Programming Language :: Python',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.4',
        'Programming Language :: Python :: 3.5',
    ],

    entry_points={
        'console_scripts': [
            'bikoserver = biko.server.__main__:main',
            'bikoclient = biko.client.__main__:main',
        ]
    },

    install_requires=[
        'autobahn[twisted]==0.15.0',
        'peewee==2.8.1',
    ]
)
